local ffi = require 'ffi'
local lj_include = require 'lj_include'

ffi.cdef[[
struct winsize {
    unsigned short int ws_row;
    unsigned short int ws_col;
    unsigned short int ws_xpixel;
    unsigned short int ws_ypixel;
};
struct termio {
    unsigned short int c_iflag;
    unsigned short int c_oflag;
    unsigned short int c_cflag;
    unsigned short int c_lflag;
    unsigned char c_line;
    unsigned char c_cc[10];
};
]]

local defs = {
    NCC = '10',
    TIOCM_LE = '0x001',
    TIOCM_DTR = '0x002',
    TIOCM_RTS = '0x004',
    TIOCM_ST = '0x008',
    TIOCM_SR = '0x010',
    TIOCM_CTS = '0x020',
    TIOCM_CAR = '0x040',
    TIOCM_RNG = '0x080',
    TIOCM_DSR = '0x100',
    TIOCM_CD = '0x040',
    TIOCM_RI = '0x080',
    N_TTY = '0',
    N_SLIP = '1',
    N_MOUSE = '2',
    N_PPP = '3',
    N_STRIP = '4',
    N_AX25 = '5',
    N_X25 = '6',
    N_6PACK = '7',
    N_MASC = '8',
    N_R3964 = '9',
    N_PROFIBUS_FDL = '10',
    N_IRDA = '11',
    N_SMSBLOCK = '12',
    N_HDLC = '13',
    N_SYNC_PPP = '14',
    N_HCI = '15',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

