local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_signum_generic')
local defs = {
    SIGSTKFLT = '16',
    SIGPWR = '30',
    SIGBUS = '7',
    SIGUSR1 = '10',
    SIGUSR2 = '12',
    SIGCHLD = '17',
    SIGCONT = '18',
    SIGSTOP = '19',
    SIGTSTP = '20',
    SIGURG = '23',
    SIGPOLL = '29',
    SIGSYS = '31',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

