local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_types')
lj_include('bits_timex')

ffi.cdef[[
int clock_adjtime(__clockid_t __clock_id, struct timex *__utx);
]]

local defs = {
    CLOCK_REALTIME = '0',
    CLOCK_MONOTONIC = '1',
    CLOCK_PROCESS_CPUTIME_ID = '2',
    CLOCK_THREAD_CPUTIME_ID = '3',
    CLOCK_MONOTONIC_RAW = '4',
    CLOCK_REALTIME_COARSE = '5',
    CLOCK_MONOTONIC_COARSE = '6',
    CLOCK_BOOTTIME = '7',
    CLOCK_REALTIME_ALARM = '8',
    CLOCK_BOOTTIME_ALARM = '9',
    CLOCK_TAI = '11',
    TIMER_ABSTIME = '1',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

