local ffi = require 'ffi'
local lj_include = require 'lj_include'

ffi.cdef[[
typedef union pthread_attr_t pthread_attr_t;
typedef struct sigevent {
    __sigval_t sigev_value;
    int sigev_signo;
    int sigev_notify;
    union {
	int _pad[((64 / sizeof(int)) - 3)];
	__pid_t _tid;
	struct {
	    void (*_function) (__sigval_t);
	    pthread_attr_t *_attribute;
	} _sigev_thread;
    } _sigev_un;
} sigevent_t;
]]

lj_include('bits_types___sigval_t')
local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

