local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_types___sigval_t')

ffi.cdef[[
typedef struct {
    int si_signo;
    int si_errno;
    int si_code;
    union {
	int _pad[((128 / sizeof(int)) - 3)];
	struct {
	    __pid_t si_pid;
	    __uid_t si_uid;
	} _kill;
	struct {
	    int si_tid;
	    int si_overrun;
	    __sigval_t si_sigval;
	} _timer;
	struct {
	    __pid_t si_pid;
	    __uid_t si_uid;
	    __sigval_t si_sigval;
	} _rt;
	struct {
	    __pid_t si_pid;
	    __uid_t si_uid;
	    int si_status;
	    __clock_t si_utime;
	    __clock_t si_stime;
	} _sigchld;
	struct {
	    void *si_addr;
	    short int si_addr_lsb;
	    union {
		struct {
		    void *_lower;
		    void *_upper;
		} _addr_bnd;
		__uint32_t _pkey;
	    } _bounds;
	} _sigfault;
	struct {
	    long int si_band;
	    int si_fd;
	} _sigpoll;
	struct {
	    void *_call_addr;
	    int _syscall;
	    unsigned int _arch;
	} _sigsys;
    } _sifields;
} siginfo_t;
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

