local ffi = require 'ffi'
local lj_include = require 'lj_include'

ffi.cdef[[
ssize_t process_vm_readv(pid_t __pid, const struct iovec *__lvec,
    unsigned long int __liovcnt,
    const struct iovec *__rvec,
    unsigned long int __riovcnt, unsigned long int __flags);
ssize_t process_vm_writev(pid_t __pid, const struct iovec *__lvec,
    unsigned long int __liovcnt,
    const struct iovec *__rvec,
    unsigned long int __riovcnt, unsigned long int __flags);
]]

local defs = {
    RWF_HIPRI = '0x00000001',
    RWF_DSYNC = '0x00000002',
    RWF_SYNC = '0x00000004',
    RWF_NOWAIT = '0x00000008',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

