local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_types')
lj_include('bits_fcntl')

ffi.cdef[[
typedef __mode_t mode_t;
typedef __off_t off_t;
typedef __off64_t off64_t;
typedef __pid_t pid_t;
]]

lj_include('bits_types_struct_timespec')
lj_include('bits_stat')

ffi.cdef[[
int fcntl(int __fd, int __cmd, ...);
int open(const char *__file, int __oflag, ...);
int open64(const char *__file, int __oflag, ...);
int openat(int __fd, const char *__file, int __oflag, ...);
int openat64(int __fd, const char *__file, int __oflag, ...);
int creat(const char *__file, mode_t __mode);
int creat64(const char *__file, mode_t __mode);
int lockf(int __fd, int __cmd, off_t __len);
int lockf64(int __fd, int __cmd, off64_t __len);
int posix_fadvise(int __fd, off_t __offset, off_t __len, int __advise);
int posix_fadvise64(int __fd, off64_t __offset, off64_t __len,
    int __advise);
int posix_fallocate(int __fd, off_t __offset, off_t __len);
int posix_fallocate64(int __fd, off64_t __offset, off64_t __len);
]]

local defs = {
    R_OK = '4',
    W_OK = '2',
    X_OK = '1',
    F_OK = '0',
    SEEK_SET = '0',
    SEEK_CUR = '1',
    SEEK_END = '2',
    AT_SYMLINK_NOFOLLOW = '0x100',
    AT_REMOVEDIR = '0x200',
    AT_SYMLINK_FOLLOW = '0x400',
    AT_NO_AUTOMOUNT = '0x800',
    AT_EMPTY_PATH = '0x1000',
    AT_EACCESS = '0x200',
    F_ULOCK = '0',
    F_LOCK = '1',
    F_TLOCK = '2',
    F_TEST = '3',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

