local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('netinet_in')
lj_include('rpc_netdb')
lj_include('bits_types_sigevent_t')
lj_include('bits_netdb')

ffi.cdef[[
int *__h_errno_location(void);
void herror(const char *__str);
const char *hstrerror(int __err_num);
struct hostent {
    char *h_name;
    char **h_aliases;
    int h_addrtype;
    int h_length;
    char **h_addr_list;
};
void sethostent(int __stay_open);
void endhostent(void);
struct hostent *gethostent(void);
struct hostent *gethostbyaddr(const void *__addr, __socklen_t __len,
    int __type);
struct hostent *gethostbyname(const char *__name);
struct hostent *gethostbyname2(const char *__name, int __af);
int gethostent_r(struct hostent *__result_buf,
    char *__buf, size_t __buflen,
    struct hostent **__result, int *__h_errnop);
int gethostbyaddr_r(const void *__addr, __socklen_t __len,
    int __type,
    struct hostent *__result_buf,
    char *__buf, size_t __buflen,
    struct hostent **__result, int *__h_errnop);
int gethostbyname_r(const char *__name,
    struct hostent *__result_buf,
    char *__buf, size_t __buflen,
    struct hostent **__result, int *__h_errnop);
int gethostbyname2_r(const char *__name, int __af,
    struct hostent *__result_buf,
    char *__buf, size_t __buflen,
    struct hostent **__result, int *__h_errnop);
void setnetent(int __stay_open);
void endnetent(void);
struct netent *getnetent(void);
struct netent *getnetbyaddr(uint32_t __net, int __type);
struct netent *getnetbyname(const char *__name);
int getnetent_r(struct netent *__result_buf,
    char *__buf, size_t __buflen,
    struct netent **__result, int *__h_errnop);
int getnetbyaddr_r(uint32_t __net, int __type,
    struct netent *__result_buf,
    char *__buf, size_t __buflen,
    struct netent **__result, int *__h_errnop);
int getnetbyname_r(const char *__name,
    struct netent *__result_buf,
    char *__buf, size_t __buflen,
    struct netent **__result, int *__h_errnop);
struct servent {
    char *s_name;
    char **s_aliases;
    int s_port;
    char *s_proto;
};
void setservent(int __stay_open);
void endservent(void);
struct servent *getservent(void);
struct servent *getservbyname(const char *__name, const char *__proto);
struct servent *getservbyport(int __port, const char *__proto);
int getservent_r(struct servent *__result_buf,
    char *__buf, size_t __buflen, struct servent **__result);
int getservbyname_r(const char *__name,
    const char *__proto,
    struct servent *__result_buf,
    char *__buf, size_t __buflen, struct servent **__result);
int getservbyport_r(int __port, const char *__proto,
    struct servent *__result_buf,
    char *__buf, size_t __buflen, struct servent **__result);
struct protoent {
    char *p_name;
    char **p_aliases;
    int p_proto;
};
void setprotoent(int __stay_open);
void endprotoent(void);
struct protoent *getprotoent(void);
struct protoent *getprotobyname(const char *__name);
struct protoent *getprotobynumber(int __proto);
int getprotoent_r(struct protoent *__result_buf,
    char *__buf, size_t __buflen, struct protoent **__result);
int getprotobyname_r(const char *__name,
    struct protoent *__result_buf,
    char *__buf, size_t __buflen, struct protoent **__result);
int getprotobynumber_r(int __proto,
    struct protoent *__result_buf,
    char *__buf, size_t __buflen, struct protoent **__result);
int setnetgrent(const char *__netgroup);
void endnetgrent(void);
int getnetgrent(char **__hostp, char **__userp, char **__domainp);
int innetgr(const char *__netgroup, const char *__host,
    const char *__user, const char *__domain);
int getnetgrent_r(char **__hostp,
    char **__userp, char **__domainp, char *__buffer, size_t __buflen);
int rcmd(char **__ahost, unsigned short int __rport,
    const char *__locuser,
    const char *__remuser, const char *__cmd, int *__fd2p);
int rcmd_af(char **__ahost, unsigned short int __rport,
    const char *__locuser,
    const char *__remuser,
    const char *__cmd, int *__fd2p, sa_family_t __af);
int rexec(char **__ahost, int __rport,
    const char *__name,
    const char *__pass, const char *__cmd, int *__fd2p);
int rexec_af(char **__ahost, int __rport,
    const char *__name,
    const char *__pass, const char *__cmd, int *__fd2p, sa_family_t __af);
int ruserok(const char *__rhost, int __suser,
    const char *__remuser, const char *__locuser);
int ruserok_af(const char *__rhost, int __suser,
    const char *__remuser, const char *__locuser, sa_family_t __af);
int iruserok(uint32_t __raddr, int __suser,
    const char *__remuser, const char *__locuser);
int iruserok_af(const void *__raddr, int __suser,
    const char *__remuser, const char *__locuser, sa_family_t __af);
int rresvport(int *__alport);
int rresvport_af(int *__alport, sa_family_t __af);
struct addrinfo {
    int ai_flags;
    int ai_family;
    int ai_socktype;
    int ai_protocol;
    socklen_t ai_addrlen;
    struct sockaddr *ai_addr;
    char *ai_canonname;
    struct addrinfo *ai_next;
};
struct gaicb {
    const char *ar_name;
    const char *ar_service;
    const struct addrinfo *ar_request;
    struct addrinfo *ar_result;
    int __return;
    int __glibc_reserved[5];
};
int getaddrinfo(const char *__name,
    const char *__service,
    const struct addrinfo *__req, struct addrinfo **__pai);
void freeaddrinfo(struct addrinfo *__ai);
const char *gai_strerror(int __ecode);
int getnameinfo(const struct sockaddr *__sa,
    socklen_t __salen, char *__host,
    socklen_t __hostlen, char *__serv, socklen_t __servlen, int __flags);
int getaddrinfo_a(int __mode, struct gaicb *__list[restrict],
    int __ent, struct sigevent *__sig);
int gai_suspend(const struct gaicb *const __list[], int __ent,
    const struct timespec *__timeout);
int gai_error(struct gaicb *__req);
int gai_cancel(struct gaicb *__gaicbp);
]]

local defs = {
    HOST_NOT_FOUND = '1',
    TRY_AGAIN = '2',
    NO_RECOVERY = '3',
    NO_DATA = '4',
    NETDB_SUCCESS = '0',
    NO_ADDRESS = '4',
    IPPORT_RESERVED = '1024',
    GAI_WAIT = '0',
    GAI_NOWAIT = '1',
    AI_PASSIVE = '0x0001',
    AI_CANONNAME = '0x0002',
    AI_NUMERICHOST = '0x0004',
    AI_V4MAPPED = '0x0008',
    AI_ALL = '0x0010',
    AI_ADDRCONFIG = '0x0020',
    AI_IDN = '0x0040',
    AI_CANONIDN = '0x0080',
    AI_IDN_ALLOW_UNASSIGNED = '0x0100',
    AI_IDN_USE_STD3_ASCII_RULES = '0x0200',
    AI_NUMERICSERV = '0x0400',
    NI_MAXHOST = '1025',
    NI_MAXSERV = '32',
    NI_NUMERICHOST = '1',
    NI_NUMERICSERV = '2',
    NI_NOFQDN = '4',
    NI_NAMEREQD = '8',
    NI_DGRAM = '16',
    NI_IDN = '32',
    NI_IDN_ALLOW_UNASSIGNED = '64',
    NI_IDN_USE_STD3_ASCII_RULES = '128',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

