local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_types')
lj_include('bits_signum')
lj_include('bits_types_sig_atomic_t')
lj_include('bits_types_sigset_t')

ffi.cdef[[
typedef __pid_t pid_t;
typedef __uid_t uid_t;
]]

lj_include('bits_types_struct_timespec')
lj_include('bits_types_siginfo_t')
lj_include('bits_siginfo_consts')
lj_include('bits_types_sigval_t')
lj_include('bits_types_sigevent_t')
lj_include('bits_sigevent_consts')

ffi.cdef[[
typedef void (*__sighandler_t) (int);
__sighandler_t __sysv_signal(int __sig, __sighandler_t __handler);
__sighandler_t sysv_signal(int __sig, __sighandler_t __handler);
__sighandler_t signal(int __sig, __sighandler_t __handler);
int kill(__pid_t __pid, int __sig);
int killpg(__pid_t __pgrp, int __sig);
int raise(int __sig);
__sighandler_t ssignal(int __sig, __sighandler_t __handler);
int gsignal(int __sig);
void psignal(int __sig, const char *__s);
void psiginfo(const siginfo_t * __pinfo, const char *__s);
int __sigpause(int __sig_or_mask, int __is_sig);
int sigblock(int __mask);
int sigsetmask(int __mask);
int siggetmask(void);
typedef __sighandler_t sighandler_t;
typedef __sighandler_t sig_t;
int sigemptyset(sigset_t * __set);
int sigfillset(sigset_t * __set);
int sigaddset(sigset_t * __set, int __signo);
int sigdelset(sigset_t * __set, int __signo);
int sigismember(const sigset_t * __set, int __signo);
int sigisemptyset(const sigset_t * __set);
int sigandset(sigset_t * __set, const sigset_t * __left,
    const sigset_t * __right);
int sigorset(sigset_t * __set, const sigset_t * __left,
    const sigset_t * __right);
]]

lj_include('bits_sigaction')

ffi.cdef[[
int sigprocmask(int __how, const sigset_t * __set, sigset_t * __oset);
int sigsuspend(const sigset_t * __set);
int sigaction(int __sig, const struct sigaction *__act,
    struct sigaction *__oact);
int sigpending(sigset_t * __set);
int sigwait(const sigset_t * __set, int *__sig);
int sigwaitinfo(const sigset_t * __set, siginfo_t * __info);
int sigtimedwait(const sigset_t * __set,
    siginfo_t * __info, const struct timespec *__timeout);
int sigqueue(__pid_t __pid, int __sig, const union sigval __val);
const char *const _sys_siglist[(64 + 1)];
const char *const sys_siglist[(64 + 1)];
]]

lj_include('bits_sigcontext')

ffi.cdef[[
int sigreturn(struct sigcontext *__scp);
]]

lj_include('stddef')
lj_include('bits_types_stack_t')
lj_include('sys_ucontext')

ffi.cdef[[
int siginterrupt(int __sig, int __interrupt);
]]

lj_include('bits_sigstack')
lj_include('bits_ss_flags')

ffi.cdef[[
int sigaltstack(const stack_t * __ss, stack_t * __oss);
]]

lj_include('bits_types_struct_sigstack')

ffi.cdef[[
int sigstack(struct sigstack *__ss, struct sigstack *__oss);
int sighold(int __sig);
int sigrelse(int __sig);
int sigignore(int __sig);
__sighandler_t sigset(int __sig, __sighandler_t __disp);
]]

lj_include('bits_pthreadtypes')
lj_include('bits_sigthread')

ffi.cdef[[
int __libc_current_sigrtmin(void);
int __libc_current_sigrtmax(void);
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

