local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('stddef')

ffi.cdef[[
void *memcpy(void *__dest, const void *__src, size_t __n);
void *memmove(void *__dest, const void *__src, size_t __n);
void *memccpy(void *__dest, const void *__src, int __c, size_t __n);
void *memset(void *__s, int __c, size_t __n);
int memcmp(const void *__s1, const void *__s2, size_t __n);
void *memchr(const void *__s, int __c, size_t __n);
void *rawmemchr(const void *__s, int __c);
void *memrchr(const void *__s, int __c, size_t __n);
char *strcpy(char *__dest, const char *__src);
char *strncpy(char *__dest, const char *__src, size_t __n);
char *strcat(char *__dest, const char *__src);
char *strncat(char *__dest, const char *__src, size_t __n);
int strcmp(const char *__s1, const char *__s2);
int strncmp(const char *__s1, const char *__s2, size_t __n);
int strcoll(const char *__s1, const char *__s2);
size_t strxfrm(char *__dest, const char *__src, size_t __n);
]]

lj_include('bits_types_locale_t')

ffi.cdef[[
int strcoll_l(const char *__s1, const char *__s2, locale_t __l);
size_t strxfrm_l(char *__dest, const char *__src, size_t __n,
    locale_t __l);
char *strdup(const char *__s);
char *strndup(const char *__string, size_t __n);
char *strchr(const char *__s, int __c);
char *strrchr(const char *__s, int __c);
char *strchrnul(const char *__s, int __c);
size_t strcspn(const char *__s, const char *__reject);
size_t strspn(const char *__s, const char *__accept);
char *strpbrk(const char *__s, const char *__accept);
char *strstr(const char *__haystack, const char *__needle);
char *strtok(char *__s, const char *__delim);
char *__strtok_r(char *__s, const char *__delim, char **__save_ptr);
char *strtok_r(char *__s, const char *__delim, char **__save_ptr);
char *strcasestr(const char *__haystack, const char *__needle);
void *memmem(const void *__haystack, size_t __haystacklen,
    const void *__needle, size_t __needlelen);
void *__mempcpy(void *__dest, const void *__src, size_t __n);
void *mempcpy(void *__dest, const void *__src, size_t __n);
size_t strlen(const char *__s);
size_t strnlen(const char *__string, size_t __maxlen);
char *strerror(int __errnum);
char *strerror_r(int __errnum, char *__buf, size_t __buflen);
char *strerror_l(int __errnum, locale_t __l);
]]

lj_include('strings')

ffi.cdef[[
void explicit_bzero(void *__s, size_t __n);
char *strsep(char **__stringp, const char *__delim);
char *strsignal(int __sig);
char *__stpcpy(char *__dest, const char *__src);
char *stpcpy(char *__dest, const char *__src);
char *__stpncpy(char *__dest, const char *__src, size_t __n);
char *stpncpy(char *__dest, const char *__src, size_t __n);
int strverscmp(const char *__s1, const char *__s2);
char *strfry(char *__string);
void *memfrob(void *__s, size_t __n);
char *basename(const char *__filename);
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

