local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_types_struct_iovec')
lj_include('stddef')
lj_include('bits_socket')
lj_include('bits_types_struct_osockaddr')

ffi.cdef[[
enum {
    SHUT_RD = 0,
    SHUT_WR,
    SHUT_RDWR
};
struct mmsghdr {
    struct msghdr msg_hdr;
    unsigned int msg_len;
};
int socket(int __domain, int __type, int __protocol);
int socketpair(int __domain, int __type, int __protocol, int __fds[2]);
int bind(int __fd, const struct sockaddr *__addr, socklen_t __len);
int getsockname(int __fd, struct sockaddr *__addr, socklen_t * __len);
int connect(int __fd, const struct sockaddr *__addr, socklen_t __len);
int getpeername(int __fd, struct sockaddr *__addr, socklen_t * __len);
ssize_t send(int __fd, const void *__buf, size_t __n, int __flags);
ssize_t recv(int __fd, void *__buf, size_t __n, int __flags);
ssize_t sendto(int __fd, const void *__buf, size_t __n,
    int __flags, const struct sockaddr *__addr, socklen_t __addr_len);
ssize_t recvfrom(int __fd, void *__buf, size_t __n,
    int __flags, struct sockaddr *__addr, socklen_t * __addr_len);
ssize_t sendmsg(int __fd, const struct msghdr *__message, int __flags);
int sendmmsg(int __fd, struct mmsghdr *__vmessages,
    unsigned int __vlen, int __flags);
ssize_t recvmsg(int __fd, struct msghdr *__message, int __flags);
int recvmmsg(int __fd, struct mmsghdr *__vmessages,
    unsigned int __vlen, int __flags, struct timespec *__tmo);
int getsockopt(int __fd, int __level, int __optname,
    void *__optval, socklen_t * __optlen);
int setsockopt(int __fd, int __level, int __optname,
    const void *__optval, socklen_t __optlen);
int listen(int __fd, int __n);
int accept(int __fd, struct sockaddr *__addr, socklen_t * __addr_len);
int accept4(int __fd, struct sockaddr *__addr,
    socklen_t * __addr_len, int __flags);
int shutdown(int __fd, int __how);
int sockatmark(int __fd);
int isfdtype(int __fd, int __fdtype);
]]

