local ffi = require 'ffi'
local lj_include = require 'lj_include'

ffi.cdef[[
struct pt_regs;
typedef unsigned long gregset_t[48];
typedef struct _libc_fpstate {
    double fpregs[32];
    double fpscr;
    unsigned int _pad[2];
} fpregset_t;
typedef struct _libc_vrstate {
    unsigned int vrregs[32][4];
    unsigned int vrsave;
    unsigned int _pad[2];
    unsigned int vscr;
} vrregset_t;
typedef struct {
    gregset_t gregs;
    fpregset_t fpregs;
    vrregset_t vrregs;
} mcontext_t;
typedef struct ucontext_t {
    unsigned long int uc_flags;
    struct ucontext_t *uc_link;
    stack_t uc_stack;
    int __glibc_reserved1[7];
    union uc_regs_ptr {
	struct pt_regs *regs;
	mcontext_t *uc_regs;
    } uc_mcontext;
    sigset_t uc_sigmask;
    char uc_reg_space[sizeof(mcontext_t) + 12];
}
ucontext_t;
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

